#include <GL/gl.h>
#include <GL/glut.h>
#include <stdlib.h>

GLint wwidth = 320;						// window width
GLint wheight = 240;					// window height

GLfloat light_ambient[] = {0.5, 0.5, 0.5, 1.0};

GLfloat light_diffuse[] = {1.0, 1.0, 1.0, 1.0};
GLfloat light_position[] = {5.0, 5.0, 5.0 };

GLfloat light1_diffuse[]  = {  0.7,  0.7, 0.7, 1.0 };
GLfloat light1_position[] = { -5.0, -5.0, 5.0 };

GLfloat wall_color[] = {1.0, 1.0, 1.0, 1.0};
GLfloat roof_color[] = {1.0, 0.0, 0.2, 1.0};
GLfloat grass_color[] = {0.0, 0.5, 0.2, 1.0};
GLfloat trunk_color[] = {0.7, 0.4, 0.0, 1.0};
GLfloat tree_color[] = {0.0, 0.7, 0.0, 1.0};
GLfloat tree_bot_color[] = {0.0, 0.2, 0.0, 1.0};

/* Koordinaten der Kameraposition: */
GLfloat    eye_x        = 0.0;
GLfloat    eye_y        = -1.0;
GLfloat    eye_z        = 12.0;

GLfloat    center_x        = 0.0;
GLfloat    center_y        = 0.0;
GLfloat    center_z        = 0.0;

GLfloat rotation[3]		= { 0, -1, 0 };	// current rotation distribution
GLfloat cAngle			= 0;			// current rotation angle
GLfloat sAngle			= 2;			// current rotation angle stepsize
GLfloat brake			= 1;			// rotation brake factor

GLfloat earth_diameter	= 2.5;

struct treeInfo {
	GLfloat a, x, y, z;					// position (rotation) info
} *tree;

//treeInfo *tree;
GLint nTrees = 50;						// total number of trees
GLint eTrees = 50;						// still existant trees

GLfloat dropAngle = 0;
GLfloat dropCounter = 0;
GLfloat dropFactor = 1;

GLfloat clickObjAngle = 0;

enum {
	none,
	timber,
	house,
	drop,
	finished
} animation = none;

void drawHouse( GLfloat angle, GLfloat x, GLfloat y, GLfloat z ) {
	glPushMatrix();
	
	glRotatef( angle, x, y, z );
	glTranslatef( 0, earth_diameter, 0 );
	
	glBegin( GL_QUADS );
	   	// 4 walls

		glColor4f( 1.0, 1.0, 1.0, 1.0 );
		glMaterialfv(GL_FRONT, GL_DIFFUSE, wall_color);
		
		glNormal3f(  0.0,  0.0, -1.0 );
		glVertex3f( -0.5,  0.0, -0.5 );
		glVertex3f( -0.5,  1.0, -0.5 );
		glVertex3f(  0.5,  1.0, -0.5 );
		glVertex3f(  0.5,  0.0, -0.5 );

		glNormal3f( -1.0,  0.0,  0.0 );
		glVertex3f( -0.5,  0.0, -0.5 );
		glVertex3f( -0.5,  0.0,  0.5 );
		glVertex3f( -0.5,  1.0,  0.5 );
		glVertex3f( -0.5,  1.0, -0.5 );

		glNormal3f(  0.0,  0.0,  1.0 );
		glVertex3f(  0.5,  0.0,  0.5 );
		glVertex3f(  0.5,  1.0,  0.5 );
		glVertex3f( -0.5,  1.0,  0.5 );
		glVertex3f( -0.5,  0.0,  0.5 );

		glNormal3f(  1.0,  0.0,  0.0 );
		glVertex3f(  0.5,  0.0,  0.5 );
		glVertex3f(  0.5,  0.0, -0.5 );
		glVertex3f(  0.5,  1.0, -0.5 );
		glVertex3f(  0.5,  1.0,  0.5 );

	glMaterialfv(GL_FRONT, GL_DIFFUSE, roof_color);
		
		// roof-floor
		glColor4f( 0.0, 0.0, 0.5, 1.0 );
		glNormal3f(  0.0, -1.0,  0.0 );
		glVertex3f(  0.7,  1.0,  0.7 );
		glVertex3f( -0.7,  1.0,  0.7 );
		glVertex3f( -0.7,  1.0, -0.7 );
		glVertex3f(  0.7,  1.0, -0.7 );
		
	glEnd();

	glBegin( GL_POLYGON );
  			// roof
		glColor4f( 1.0, 0.0, 0.0, 1.0 );
		
		glNormal3f(  1.0,  1.0,  0.0 );
		glVertex3f(  0.7,  1.0, -0.7 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f(  0.7,  1.0,  0.7 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f(  0.0,  1.0,  1.0 );
		glVertex3f(  0.7,  1.0,  0.7 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f( -0.7,  1.0,  0.7 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f( -1.0,  1.0,  0.0 );
		glVertex3f( -0.7,  1.0,  0.7 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f( -0.7,  1.0, -0.7 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f(  0.0,  1.0, -1.0 );
		glVertex3f( -0.7,  1.0, -0.7 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f(  0.7,  1.0, -0.7 );
	glEnd();

	glPopMatrix();
}

void drawTree( GLfloat angle, GLfloat x, GLfloat y, GLfloat z ) {
	glPushMatrix();
	
	glRotatef( angle, x, y, z );
	glTranslatef( 0, earth_diameter, 0 );
	
	glBegin( GL_QUADS );
	   	// trunk
		glColor4f( 1.0, 1.0, 1.0, 1.0 );
		glMaterialfv(GL_FRONT, GL_DIFFUSE, trunk_color);
		
		glNormal3f(  0.0,  0.0, -1.0 );
		glVertex3f( -0.1,  0.0, -0.1 );
		glVertex3f( -0.1,  0.5, -0.1 );
		glVertex3f(  0.1,  0.5, -0.1 );
		glVertex3f(  0.1,  0.0, -0.1 );

		glNormal3f( -1.0,  0.0,  0.0 );
		glVertex3f( -0.1,  0.0, -0.1 );
		glVertex3f( -0.1,  0.0,  0.1 );
		glVertex3f( -0.1,  0.5,  0.1 );
		glVertex3f( -0.1,  0.5, -0.1 );

		glNormal3f(  0.0,  0.0,  1.0 );
		glVertex3f(  0.1,  0.0,  0.1 );
		glVertex3f(  0.1,  0.5,  0.1 );
		glVertex3f( -0.1,  0.5,  0.1 );
		glVertex3f( -0.1,  0.0,  0.1 );

		glNormal3f(  1.0,  0.0,  0.0 );
		glVertex3f(  0.1,  0.0,  0.1 );
		glVertex3f(  0.1,  0.0, -0.1 );
		glVertex3f(  0.1,  0.5, -0.1 );
		glVertex3f(  0.1,  0.5,  0.1 );
		
		// crown "floor"
		glMaterialfv(GL_FRONT, GL_DIFFUSE, tree_bot_color);
		glNormal3f(  0.0, -1.0,  0.0 );
		glVertex3f(  0.3,  0.5,  0.3 );
		glVertex3f( -0.3,  0.5,  0.3 );
		glVertex3f( -0.3,  0.5, -0.3 );
		glVertex3f(  0.3,  0.5, -0.3 );
		
	glEnd();

	glMaterialfv(GL_FRONT, GL_DIFFUSE, tree_color);

	glBegin( GL_POLYGON );
		glColor4f( 0.0, 1.0, 0.0, 1.0 );
		
		glNormal3f(  1.0,  1.0,  0.0 );
		glVertex3f(  0.3,  0.5, -0.3 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f(  0.3,  0.5,  0.3 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f(  0.0,  1.0,  1.0 );
		glVertex3f(  0.3,  0.5,  0.3 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f( -0.3,  0.5,  0.3 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f( -1.0,  1.0,  0.0 );
		glVertex3f( -0.3,  0.5,  0.3 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f( -0.3,  0.5, -0.3 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f(  0.0,  1.0, -1.0 );
		glVertex3f( -0.3,  0.5, -0.3 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f(  0.3,  0.5, -0.3 );
	glEnd();
	glPopMatrix();
}

void createForest( GLint upper ) { // upper=0: lower forest, upper=1: upper forest
	int i;
	for( i=(nTrees/2)*upper; i<nTrees/(2-upper); i++ ) {
		tree[i].a = (rand() % 90);
		if( upper == 0 ) tree[i].a += 180;
		tree[i].x = (((float)rand())/(RAND_MAX/2))-1;
		tree[i].y = 0; //(((float)rand())/(RAND_MAX/2))-1;
		tree[i].z = (((float)rand())/(RAND_MAX/2))-1;
	}
}

void drawEarth( void ) {
	int i;

	glPushMatrix();
		glMaterialfv( GL_FRONT, GL_DIFFUSE, grass_color);
		glutSolidSphere( earth_diameter+0.2, 16, 16 );
	glPopMatrix();

	if( animation == drop )
		drawHouse( 0, 0, 0, 0 );

	for( i=0; i<eTrees; i++ ) {
		drawTree( tree[i].a, tree[i].x, tree[i].y, tree[i].z );
	}
}

void display( void ) {
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	
	glPushMatrix();
		if( animation == drop ) {
			glRotatef( 180-dropAngle, 0, 0, 1 );
		}
		glRotatef( cAngle, rotation[0], rotation[1], rotation[2] );
		drawEarth();
	
	glPopMatrix();
	

	glPushMatrix();
	glScalef( 0.75, 0.75, 0.75 );
	glTranslatef( -6.5, -7, 0 );
	glRotatef( clickObjAngle, 0, 1, 0 );
	clickObjAngle -= 5;
	
	if( animation == none ) 
		drawTree( 0, 0, 0, 0 );
	else if( animation == house ) 
		drawHouse( 0, 0, 0, 0 );
	
	glPopMatrix();
	glPopMatrix();

	glutSwapBuffers();
}

void init( void ) {
	
	glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);

	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	glEnable(GL_LIGHT0);

	glLightfv(GL_LIGHT1, GL_DIFFUSE, light1_diffuse);
	glLightfv(GL_LIGHT1, GL_POSITION, light1_position);
	glEnable(GL_LIGHT1);

	glEnable(GL_LIGHTING);
	
	glShadeModel( GL_SMOOTH );

	glEnable(GL_DEPTH_TEST);
	
	// Setup the view
	glMatrixMode(GL_PROJECTION);

	gluPerspective(40.0,           /* field of view in degree */ 
	               (float)wwidth/wheight, /* aspect ratio */ 
	               2.0,            /* Z near (distance to the near clipping plane) */    
	               20000.0);       /* Z far  (distance to the far clipping plane.) */ 

	glMatrixMode(GL_MODELVIEW);

	createForest( 0 );
	createForest( 1 );
}

void idle( void ) { 
	sAngle *= brake;
	cAngle += sAngle;
	
	if( eTrees < nTrees/2 && animation==timber ) animation=house;
	if( animation == timber ) eTrees-=2;
	if( animation == drop && dropFactor > 0.01 ) {
		while( dropAngle > 360 ) dropAngle-=360;
		while( dropAngle <   0 ) dropAngle+=360;

		dropAngle = dropFactor * 180 * cosf( dropCounter );
		dropCounter+=0.25;
		dropFactor *= 0.93;
	}
	 
	glutPostRedisplay();
}

void mouse( int button, int state, int x, int y ) {
  if( (button == GLUT_LEFT_BUTTON) && (state == GLUT_DOWN) ) {
	switch( animation ) {
		case none:
			animation=timber;
			break;
		case timber:
			break;
		case house:
			animation=drop;
			break;
		case finished:
			eTrees = nTrees;
			animation=none;
			break;
		default:
			break;
	}
  } else if( (button == GLUT_LEFT_BUTTON) && (state == GLUT_UP) ) {
  }
  return ;
}

int main( int argc, char **argv ) {
	tree = malloc( sizeof(struct treeInfo) * nTrees );

	glutInit( &argc, argv );
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );

	glutInitWindowSize( wwidth, wheight );
	glutInitWindowPosition( 100, 100 );
	glutCreateWindow( "Mother Earth - Animation" );

	glutDisplayFunc( display );
	glutIdleFunc( idle );
	glutMouseFunc( mouse );

	gluLookAt(eye_x, eye_y, eye_z,		// eye
		center_x, center_y, center_z, 	// center
		0.0, 1.0, 0.0);					// up

	init();
	glutMainLoop();

	free( tree );
	return 0;             /* ANSI C requires main to return int. */
}

// technicolor ends here
