#include <GL/gl.h>
#include <GL/glut.h>
#include <stdlib.h>
#include <string.h>

int wwidth = 320;						// window width
int wheight = 240;						// window height
int bwidth = 50;						// button width
int bheight = 50;						// button height

GLfloat light_ambient[] = {0.5, 0.5, 0.5, 1.0};

GLfloat light_diffuse[] = {1.0, 1.0, 1.0, 1.0};
GLfloat light_position[] = {5.0, 5.0, 5.0 };

GLfloat light1_diffuse[]  = {  0.7,  0.7, 0.7, 1.0 };
GLfloat light1_position[] = { -5.0, -5.0, 5.0 };

GLfloat wall_color[] = {1.0, 1.0, 1.0, 1.0};
GLfloat roof_color[] = {1.0, 0.0, 0.2, 1.0};
GLfloat grass_color[] = {0.0, 0.5, 0.2, 1.0};
GLfloat trunk_color[] = {0.7, 0.4, 0.0, 1.0};
GLfloat tree_color[] = {0.0, 0.7, 0.0, 1.0};
GLfloat tree_bot_color[] = {0.0, 0.2, 0.0, 1.0};

const GLfloat earth_diameter	= 2.5;

/* Koordinaten der Kameraposition: */
GLfloat    eye_x        = 0.0;
GLfloat    eye_y        = 3.5;
GLfloat    eye_z        = 10.0;

GLfloat    center_x        = 0.0;
GLfloat    center_y        = 2.7;
GLfloat    center_z        = 0.0;

GLint   charlie[2]		= { 0, 0 };		// charlie marks the point where the user clicked down
GLfloat rotation[3]		= { 0, 0, 0 };	// current rotation
GLfloat rotspeed[3]		= { 0, 0, 0 };	// current rotation speed
GLfloat cAngle			= 0;			// current rotation angle
GLfloat sAngle			= 2;			// current rotation angle stepsize
GLfloat brake			= 0.85;			// rotation brake factor

struct treeInfo {
	GLfloat a, x, y, z;					// position (rotation) info
} *tree;

//treeInfo *tree;
GLint nTrees = 50;						// total number of trees
GLint eTrees = 50;						// still existant trees

//////////////////////////////////////////////////////////////////
// functions

void drawHouse( GLfloat angle, GLfloat x, GLfloat y, GLfloat z ) {
	glPushMatrix();
	
	glRotatef( angle, x, y, z );
	glTranslatef( 0, earth_diameter, 0 );
	
	glBegin( GL_QUADS );
	   	// 4 walls

		glColor4f( 1.0, 1.0, 1.0, 1.0 );
		glMaterialfv(GL_FRONT, GL_DIFFUSE, wall_color);
		
		glNormal3f(  0.0,  0.0, -1.0 );
		glVertex3f( -0.5,  0.0, -0.5 );
		glVertex3f( -0.5,  1.0, -0.5 );
		glVertex3f(  0.5,  1.0, -0.5 );
		glVertex3f(  0.5,  0.0, -0.5 );

		glNormal3f( -1.0,  0.0,  0.0 );
		glVertex3f( -0.5,  0.0, -0.5 );
		glVertex3f( -0.5,  0.0,  0.5 );
		glVertex3f( -0.5,  1.0,  0.5 );
		glVertex3f( -0.5,  1.0, -0.5 );

		glNormal3f(  0.0,  0.0,  1.0 );
		glVertex3f(  0.5,  0.0,  0.5 );
		glVertex3f(  0.5,  1.0,  0.5 );
		glVertex3f( -0.5,  1.0,  0.5 );
		glVertex3f( -0.5,  0.0,  0.5 );

		glNormal3f(  1.0,  0.0,  0.0 );
		glVertex3f(  0.5,  0.0,  0.5 );
		glVertex3f(  0.5,  0.0, -0.5 );
		glVertex3f(  0.5,  1.0, -0.5 );
		glVertex3f(  0.5,  1.0,  0.5 );

	glMaterialfv(GL_FRONT, GL_DIFFUSE, roof_color);
		
		// roof-floor
		glColor4f( 0.0, 0.0, 0.5, 1.0 );
		glNormal3f(  0.0, -1.0,  0.0 );
		glVertex3f(  0.7,  1.0,  0.7 );
		glVertex3f( -0.7,  1.0,  0.7 );
		glVertex3f( -0.7,  1.0, -0.7 );
		glVertex3f(  0.7,  1.0, -0.7 );
		
	glEnd();

	glBegin( GL_POLYGON );
  			// roof
		glColor4f( 1.0, 0.0, 0.0, 1.0 );
		
		glNormal3f(  1.0,  1.0,  0.0 );
		glVertex3f(  0.7,  1.0, -0.7 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f(  0.7,  1.0,  0.7 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f(  0.0,  1.0,  1.0 );
		glVertex3f(  0.7,  1.0,  0.7 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f( -0.7,  1.0,  0.7 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f( -1.0,  1.0,  0.0 );
		glVertex3f( -0.7,  1.0,  0.7 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f( -0.7,  1.0, -0.7 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f(  0.0,  1.0, -1.0 );
		glVertex3f( -0.7,  1.0, -0.7 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f(  0.7,  1.0, -0.7 );
	glEnd();

	glPopMatrix();
}

void drawTree( GLfloat angle, GLfloat x, GLfloat y, GLfloat z ) {
	glPushMatrix();
	
	glRotatef( angle, x, y, z );
	glTranslatef( 0, earth_diameter, 0 );
	
	glBegin( GL_QUADS );
	   	// trunk
		glColor4f( 1.0, 1.0, 1.0, 1.0 );
		glMaterialfv(GL_FRONT, GL_DIFFUSE, trunk_color);
		
		glNormal3f(  0.0,  0.0, -1.0 );
		glVertex3f( -0.1,  0.0, -0.1 );
		glVertex3f( -0.1,  0.5, -0.1 );
		glVertex3f(  0.1,  0.5, -0.1 );
		glVertex3f(  0.1,  0.0, -0.1 );

		glNormal3f( -1.0,  0.0,  0.0 );
		glVertex3f( -0.1,  0.0, -0.1 );
		glVertex3f( -0.1,  0.0,  0.1 );
		glVertex3f( -0.1,  0.5,  0.1 );
		glVertex3f( -0.1,  0.5, -0.1 );

		glNormal3f(  0.0,  0.0,  1.0 );
		glVertex3f(  0.1,  0.0,  0.1 );
		glVertex3f(  0.1,  0.5,  0.1 );
		glVertex3f( -0.1,  0.5,  0.1 );
		glVertex3f( -0.1,  0.0,  0.1 );

		glNormal3f(  1.0,  0.0,  0.0 );
		glVertex3f(  0.1,  0.0,  0.1 );
		glVertex3f(  0.1,  0.0, -0.1 );
		glVertex3f(  0.1,  0.5, -0.1 );
		glVertex3f(  0.1,  0.5,  0.1 );
		
		// crown "floor"
		glMaterialfv(GL_FRONT, GL_DIFFUSE, tree_bot_color);
		glNormal3f(  0.0, -1.0,  0.0 );
		glVertex3f(  0.3,  0.5,  0.3 );
		glVertex3f( -0.3,  0.5,  0.3 );
		glVertex3f( -0.3,  0.5, -0.3 );
		glVertex3f(  0.3,  0.5, -0.3 );
		
	glEnd();

	glMaterialfv(GL_FRONT, GL_DIFFUSE, tree_color);

	glBegin( GL_POLYGON );
		glColor4f( 0.0, 1.0, 0.0, 1.0 );
				
		glNormal3f(  1.0,  1.0,  0.0 );
		glVertex3f(  0.3,  0.5, -0.3 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f(  0.3,  0.5,  0.3 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f(  0.0,  1.0,  1.0 );
		glVertex3f(  0.3,  0.5,  0.3 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f( -0.3,  0.5,  0.3 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f( -1.0,  1.0,  0.0 );
		glVertex3f( -0.3,  0.5,  0.3 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f( -0.3,  0.5, -0.3 );
  		glEnd();

  		glBegin( GL_POLYGON );
		glNormal3f(  0.0,  1.0, -1.0 );
		glVertex3f( -0.3,  0.5, -0.3 );
		glVertex3f(  0.0,  1.7,  0.0 );
		glVertex3f(  0.3,  0.5, -0.3 );
	glEnd();
	glPopMatrix();
}

void createForest() {
	int i;
	for( i=0; i<nTrees; i++ ) {
		while( tree[i].a < 25 ) tree[i].a = (rand() % 170);
		tree[i].x = (((float)rand())/(RAND_MAX/2))-1;
		tree[i].y = 0;
		tree[i].z = (((float)rand())/(RAND_MAX/2))-1;
	}
}

void drawEarth( void ) {
	int i;

	glPushMatrix();
		glMaterialfv( GL_FRONT, GL_DIFFUSE, grass_color);
		glutSolidSphere( earth_diameter+0.2, 32, 32 );
	glPopMatrix();

		drawHouse( 0, 0, 0, 0 );

	for( i=0; i<eTrees; i++ ) {
		drawTree( tree[i].a, tree[i].x, tree[i].y, tree[i].z );
	}
	
}

void init( void ) {
	
	glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);

	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	glEnable(GL_LIGHT0);

	glLightfv(GL_LIGHT1, GL_DIFFUSE, light1_diffuse);
	glLightfv(GL_LIGHT1, GL_POSITION, light1_position);
	glEnable(GL_LIGHT1);

	glEnable(GL_LIGHTING);
	
	glShadeModel( GL_SMOOTH );

	glEnable(GL_DEPTH_TEST);
	
	// Setup the view
	glMatrixMode(GL_PROJECTION);

	gluPerspective(40.0,           /* field of view in degree */ 
	               (float)wwidth/wheight, /* aspect ratio */ 
	               1.00,            /* Z near (distance to the near clipping plane) */    
	               10000.0);       /* Z far  (distance to the far clipping plane.) */ 

	glMatrixMode(GL_MODELVIEW);

	createForest();
}

void display( void ) {
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	
	glPushMatrix();

		glRotatef( rotation[1], 0, 1, 0 );
		glRotatef( rotation[0], 1, 0, 0 );
		glRotatef( rotation[2], 0, 0, 1 );
		drawEarth();
	
	glPopMatrix();

	glutSwapBuffers();
}

void idle( void ) { 
	rotspeed[0] *= brake;
//	rotspeed[1] *= brake;
	rotspeed[2] *= brake;

	rotation[0] += rotspeed[0];
	rotation[1] += rotspeed[1];
	rotation[2] += rotspeed[2];
		 
	glutPostRedisplay();
}

void mouse( int button, int state, int x, int y ) {
  if( (button == GLUT_LEFT_BUTTON) && (state == GLUT_DOWN) ) {
	charlie[0] = x;
  	charlie[1] = y;
  } else if( (button == GLUT_LEFT_BUTTON) && (state == GLUT_UP) ) {
  }
}

void mouse_motion( int x, int y ) {
	GLint dx = charlie[0] - x;
	GLint dy = charlie[1] - y;

	rotspeed[2] -= ((float)dx/wwidth)*100;
	rotspeed[0] -= ((float)dy/wheight)*100;
	
	charlie[0] = x;
	charlie[1] = y;
}

int main( int argc, char **argv ) {
	tree = malloc( sizeof(struct treeInfo) * nTrees );

	glutInit( &argc, argv );
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );

	glutInitWindowSize( wwidth, wheight );
	glutInitWindowPosition( 100, 100 );

	glutCreateWindow("Mother Earth - Interaction");

	glutDisplayFunc( display );
	glutIdleFunc( idle );
	glutMotionFunc( mouse_motion );
	glutMouseFunc( mouse );

	gluLookAt(eye_x, eye_y, eye_z,		// eye
		center_x, center_y, center_z, 	// center
		0.0, 1.0, 0.0);					// up

	init();
	glutMainLoop();

	free( tree );
	return 0;             /* ANSI C requires main to return int. */
}

// technicolor ends here
